diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/powerpc/ppc-eabi.mt gdb-6.0/gdb/config/powerpc/ppc-eabi.mt
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/powerpc/ppc-eabi.mt	Wed May 29 20:21:53 2002
+++ gdb-6.0/gdb/config/powerpc/ppc-eabi.mt	Tue Feb 17 12:43:37 2004
@@ -1,3 +1,3 @@
 # Target: PowerPC running eabi
-TDEPFILES= rs6000-tdep.o monitor.o dsrec.o ppcbug-rom.o dink32-rom.o ppc-bdm.o ocd.o remote-sds.o ppc-sysv-tdep.o solib.o solib-svr4.o
+TDEPFILES= rs6000-tdep.o monitor.o dsrec.o ppcbug-rom.o dink32-rom.o ppc-bdm.o ocd.o remote-sds.o ppc-sysv-tdep.o solib.o solib-svr4.o ppc2dink32-rom.o
 TM_FILE= tm-ppc-eabi.h
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/powerpc/ppc-sim.mt gdb-6.0/gdb/config/powerpc/ppc-sim.mt
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/powerpc/ppc-sim.mt	Wed May 29 20:21:53 2002
+++ gdb-6.0/gdb/config/powerpc/ppc-sim.mt	Tue Feb 17 12:43:37 2004
@@ -1,5 +1,5 @@
 # Target: PowerPC running eabi and including the simulator
-TDEPFILES= rs6000-tdep.o monitor.o dsrec.o ppcbug-rom.o dink32-rom.o ppc-bdm.o ocd.o remote-sds.o ppc-sysv-tdep.o solib.o solib-svr4.o
+TDEPFILES= rs6000-tdep.o monitor.o dsrec.o ppcbug-rom.o dink32-rom.o ppc-bdm.o ocd.o remote-sds.o ppc-sysv-tdep.o solib.o solib-svr4.o ppc2dink32-rom.o
 TM_FILE= tm-ppc-eabi.h
 
 SIM_OBS = remote-sim.o
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/sparc/sparc-em.mt gdb-6.0/gdb/config/sparc/sparc-em.mt
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/sparc/sparc-em.mt	Thu Apr 15 20:34:25 1999
+++ gdb-6.0/gdb/config/sparc/sparc-em.mt	Tue Feb 17 12:43:37 2004
@@ -1,3 +1,7 @@
 # Target: SPARC embedded
 TDEPFILES= sparc-tdep.o
 TM_FILE= tm-spc-em.h
+
+SIM_OBS = remote-sim.o
+SIM = ../sim/erc32/libsim.a
+
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/sparc/sun4sol2.mh gdb-6.0/gdb/config/sparc/sun4sol2.mh
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/config/sparc/sun4sol2.mh	Thu Jan 17 22:51:08 2002
+++ gdb-6.0/gdb/config/sparc/sun4sol2.mh	Tue Feb 17 12:43:37 2004
@@ -1,7 +1,7 @@
 # Host: Sun 4 or Sparcstation, running Solaris 2
 
 XM_FILE= xm-sun4sol2.h
-XM_CLIBS= -lsocket -lnsl
+XM_CLIBS= -lsocket -lnsl -ldl
 
 NAT_FILE= nm-sun4sol2.h
 NATDEPFILES= corelow.o core-sol2.o solib.o solib-svr4.o solib-legacy.o \
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/configure.tgt gdb-6.0/gdb/configure.tgt
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/configure.tgt	Mon Aug 25 17:57:50 2003
+++ gdb-6.0/gdb/configure.tgt	Tue Feb 17 12:43:17 2004
@@ -53,6 +53,7 @@
 arm*-*-netbsd*)		gdb_target=nbsd
 			gdb_multi_arch=yes ;;
 arm-*-nto*)		gdb_target=nto ;;
++arm*-*-rtems* | thumb*-*-rtems* | strongarm*-*-rtems* | \
 arm*-*-* | thumb*-*-* | strongarm*-*-*)
 			gdb_target=embed
                         configdirs="$configdirs rdi-share"
@@ -69,7 +70,7 @@
 
 d10v-*-*)		gdb_target=d10v ;;
 
-h8300-*-*)		gdb_target=h8300 ;;
+h8300-*-rtems* | h8300-*-*)	gdb_target=h8300 ;;
 # OBSOLETE h8500-*-*)		gdb_target=h8500 ;;
 
 
@@ -106,6 +107,7 @@
 		configdirs="${configdirs} nlm" ;;
 i[34567]86-*-cygwin*)	gdb_target=cygwin  ;;
 i[34567]86-*-vxworks*)	gdb_target=vxworks ;;
+i[34567]86-*-rtems*)	gdb_target=embed ;;
 i[34567]86-*-*)		gdb_target=embed ;;
 
 ia64-*-aix*)		gdb_target=aix ;;
@@ -130,6 +132,7 @@
 m68*-*-aout*)		gdb_target=monitor ;;
 m68*-*-coff*)		gdb_target=monitor ;;
 m68*-*-elf*)		gdb_target=monitor ;;
+m68*-*-rtems*)		gdb_target=monitor ;;
 m68*-*-linux*)		gdb_target=linux
 			gdb_multi_arch=1
 			build_gdbserver=yes
@@ -155,7 +158,9 @@
 mips*-*-pe)		gdb_target=wince ;;
 mips64*el-*-ecoff*)	gdb_target=embedl64 ;;
 mips64*-*-ecoff*)	gdb_target=embed64 ;;
+mips64*-*-rtems*)	gdb_target=embed64 ;;
 mips64*vr*-*-elf*)	gdb_target=mips64 ;;
+mips*tx39*-rtems*)	gdb_target=tx39 ;;
 mips*tx39*-elf*)	gdb_target=tx39 ;;
 mips64*el-*-elf*)	gdb_target=embedl64 ;;
 mips64*-*-elf*)		gdb_target=embed64 ;;
@@ -164,6 +169,8 @@
 mips*-*-ecoff*)		gdb_target=embed ;;
 mips*el-*-elf*)		gdb_target=embedl ;;
 mips*-*-elf*)		gdb_target=embed ;;
+mips*el-*-rtems*)	gdb_target=embedl ;;
+mips*-*-rtems*)		gdb_target=embed ;;
 mips*-little-*)		gdb_target=mips ;;
 mips*-*-lnews*)		gdb_target=embedl ;;
 mips*-sgi-irix5*)	gdb_target=irix5 ;;
@@ -195,7 +202,8 @@
 			;;
 powerpc64-*-linux*)	gdb_target=linux ;;
 powerpc-*-vxworks*)	gdb_target=vxworks ;;
-powerpc*-*-*)		if test -f ../sim/ppc/Makefile; then
+powerpc*-*-* | powerpc*-*-*)
+			if test -f ../sim/ppc/Makefile; then
 			  gdb_target=ppc-sim
 			else
 			  gdb_target=ppc-eabi
@@ -215,6 +223,7 @@
 sh*-*-pe)		gdb_target=wince ;;
 sh-*-coff*)		gdb_target=embed ;;
 sh-*-elf*)		gdb_target=embed ;;
+sh-*-rtems*)		gdb_target=embed ;;
 sh-*-linux*)		gdb_target=linux
 			build_gdbserver=yes
 			;;
@@ -228,6 +237,7 @@
 sparc-*-linux*)		gdb_target=linux ;;
 sparc-*-lynxos*)	gdb_target=sparclynx ;;
 sparc-*-netbsd*)	gdb_target=nbsd ;;
+sparc-*-rtems*)		gdb_target=sparc-em ;;
 sparc-*-solaris2*)	gdb_target=sun4sol2 ;;
 sparc-*-sunos4*)	gdb_target=sun4os4 ;;
 sparc-*-sunos5*)	gdb_target=sun4sol2 ;;
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/ppc2dink32-rom.c gdb-6.0/gdb/ppc2dink32-rom.c
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/ppc2dink32-rom.c	Wed Dec 31 18:00:00 1969
+++ gdb-6.0/gdb/ppc2dink32-rom.c	Tue Feb 17 12:43:37 2004
@@ -0,0 +1,201 @@
+/* Remote debugging interface between the DINK32 (PowerPC) ROM monitor 
+   as found on the Radstone PPC2 VMEbus boards and GDB, the GNU debugger.
+   Copyright 1997 Free Software Foundation, Inc.
+
+This file is part of GDB.
+
+This program is free software; you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation; either version 2 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program; if not, write to the Free Software
+Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.  */
+
+#include "defs.h"
+#include "gdbcore.h"
+#include "target.h"
+#include "monitor.h"
+#include "serial.h"
+#include "symfile.h" /* For generic_load() */
+#include "inferior.h" /* For write_pc() */
+#include "regcache.h"
+
+static void ppc2dink32_open PARAMS ((char *args, int from_tty));
+
+static void
+ppc2dink32_supply_register (regname, regnamelen, val, vallen)
+     char *regname;
+     int regnamelen;
+     char *val;
+     int vallen;
+{
+  int regno = 0, base = 0;
+
+  if (regnamelen < 2 || regnamelen > 4)
+    return;
+
+  switch (regname[0])
+    {
+    case 'R':
+      if (regname[1] < '0' || regname[1] > '9')
+	return;
+      if (regnamelen == 2)
+	regno = regname[1] - '0';
+      else if (regnamelen == 3 && regname[2] >= '0' && regname[2] <= '9')
+	regno = (regname[1] - '0') * 10 + (regname[2] - '0');
+      else
+	return;
+      break;
+    case 'F':
+      if (regname[1] != 'R' || regname[2] < '0' || regname[2] > '9')
+	return;
+      if (regnamelen == 3)
+	regno = 32 + regname[2] - '0';
+      else if (regnamelen == 4 && regname[3] >= '0' && regname[3] <= '9')
+	regno = 32 + (regname[2] - '0') * 10 + (regname[3] - '0');
+      else
+	return;
+      break;
+    case 'I':
+      if (regnamelen != 2 || regname[1] != 'P')
+	return;
+      regno = 64;
+      break;
+    case 'M':
+      if (regnamelen != 3 || regname[1] != 'S' || regname[2] != 'R')
+	return;
+      regno = 65;
+      break;
+    case 'C':
+      if (regnamelen != 2 || regname[1] != 'R')
+	return;
+      regno = 66;
+      break;
+    case 'S':
+      if (regnamelen != 4 || regname[1] != 'P' || regname[2] != 'R')
+	return;
+      else if (regname[3] == '8')
+	regno = 67;
+      else if (regname[3] == '9')
+	regno = 68;
+      else if (regname[3] == '1')
+	regno = 69;
+      else if (regname[3] == '0')
+	regno = 70;
+      else
+	return;
+      break;
+    default:
+      return;
+    }
+
+  monitor_supply_register (regno, val);
+}
+
+static void
+ppc2dink32_load (monops, filename, from_tty)
+     struct monitor_ops *monops;
+     char *filename;
+     int from_tty;
+{
+  generic_load (filename, from_tty);
+
+  /* Finally, make the PC point at the start address */
+  if (exec_bfd)
+    write_pc (bfd_get_start_address (exec_bfd));
+
+  inferior_ptid = null_ptid;		/* No process now */
+}
+
+
+/* This array of registers needs to match the indexes used by GDB. The
+   whole reason this exists is because the various ROM monitors use
+   different names than GDB does, and don't support all the registers
+   either.  */
+
+static char *ppc2dink32_regnames[] =
+{
+  "r0",   "r1",   "r2",   "r3",   "r4",   "r5",   "r6",   "r7",
+  "r8",   "r9",   "r10",  "r11",  "r12",  "r13",  "r14",  "r15",
+  "r16",  "r17",  "r18",  "r19",  "r20",  "r21",  "r22",  "r23",
+  "r24",  "r25",  "r26",  "r27",  "r28",  "r29",  "r30",  "r31",
+
+  "f0",   "f1",   "f2",   "f3",   "f4",   "f5",   "f6",   "f7",
+  "f8",   "f9",   "f10",  "f11",  "f12",  "f13",  "f14",  "f15",
+  "f16",  "f17",  "f18",  "f19",  "f20",  "f21",  "f22",  "f23",
+  "f24",  "f25",  "f26",  "f27",  "f28",  "f29",  "f30",  "f31",
+
+  "srr0", "msr",  "cr",   "lr",   "ctr",  "xer",  "xer"
+};
+
+static struct target_ops ppc2dink32_ops;
+
+static char *ppc2dink32_inits[] = {"\r", NULL};
+
+static struct monitor_ops ppc2dink32_cmds;
+
+static void
+ppc2dink32_open (args, from_tty)
+     char *args;
+     int from_tty;
+{
+  monitor_open (args, &ppc2dink32_cmds, from_tty);
+}
+
+void
+_initialize_ppc2dink32_rom ()
+{
+  ppc2dink32_cmds.flags = MO_HEX_PREFIX | MO_GETMEM_NEEDS_RANGE | MO_FILL_USES_ADDR | MO_HANDLE_NL | MO_32_REGS_PAIRED | MO_SETREG_INTERACTIVE | MO_SETMEM_INTERACTIVE | MO_CLR_BREAK_1_BASED | MO_SREC_ACK | MO_SREC_ACK_ROTATE;
+  ppc2dink32_cmds.init = ppc2dink32_inits;
+  ppc2dink32_cmds.cont = "go +\r";
+  ppc2dink32_cmds.step = "tr +\r";
+  ppc2dink32_cmds.set_break = "bp 0x%x\r";
+  ppc2dink32_cmds.clr_break = "bp %d\r";
+#if 0 /* Would need to follow strict alignment rules.. */
+  ppc2dink32_cmds.fill = "mf %x %x %x\r";
+#endif
+  ppc2dink32_cmds.setmem.cmdb = "mm -b %x\r";
+  ppc2dink32_cmds.setmem.cmdw = "mm -h %x\r";
+  ppc2dink32_cmds.setmem.cmdl = "mm %x\r";
+  ppc2dink32_cmds.setmem.term = " ?  ";
+  ppc2dink32_cmds.getmem.cmdb = "md -b %x-%x\r";
+  ppc2dink32_cmds.getmem.cmdw = "md -h %x-%x\r";
+  ppc2dink32_cmds.getmem.cmdl = "md -w %x-%x\r";
+  ppc2dink32_cmds.getmem.resp_delim = "";
+  ppc2dink32_cmds.setreg.cmd = "rm %s\r";
+  ppc2dink32_cmds.setreg.term = " ?  ";
+  ppc2dink32_cmds.getreg.cmd = "rd %s\r";
+  ppc2dink32_cmds.getreg.resp_delim = ": ";
+  ppc2dink32_cmds.dump_registers = "rd r0-r31\r";
+  ppc2dink32_cmds.register_pattern = "\\(\\w+\\) +=\\([0-9a-fA-F]+\\b\\)";
+  ppc2dink32_cmds.supply_register = ppc2dink32_supply_register;
+  /* S-record download, via "keyboard port".  */
+  ppc2dink32_cmds.load = "dl -k\r";
+  ppc2dink32_cmds.loadresp = "Set Input Port : set to Keyboard Port\r";
+#if 0 /* slow load routine not needed if S-records work... */
+  ppc2dink32_cmds.load_routine = ppc2dink32_load;
+#endif
+  ppc2dink32_cmds.prompt = "DINK32 >>";
+  ppc2dink32_cmds.line_term = "\r";
+  ppc2dink32_cmds.target = &ppc2dink32_ops;
+  ppc2dink32_cmds.stopbits = SERIAL_1_STOPBITS;
+  ppc2dink32_cmds.regnames = ppc2dink32_regnames;
+  ppc2dink32_cmds.magic = MONITOR_OPS_MAGIC;
+
+  init_monitor_ops (&ppc2dink32_ops);
+
+  ppc2dink32_ops.to_shortname = "ppc2dink32";
+  ppc2dink32_ops.to_longname = "Radstone PPC2 DINK32 monitor";
+  ppc2dink32_ops.to_doc = "Debug using the Radstone PPC2 DINK32 monitor.\n\
+Specify the serial device it is connected to (e.g. /dev/ttya).";
+  ppc2dink32_ops.to_open = ppc2dink32_open;
+
+  add_target (&ppc2dink32_ops);
+}
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/gdb/rdi-share/hsys.c gdb-6.0/gdb/rdi-share/hsys.c
--- /usr1/rtems/work-tools/original/gdb-6.0/gdb/rdi-share/hsys.c	Fri Feb 25 10:37:32 2000
+++ gdb-6.0/gdb/rdi-share/hsys.c	Tue Feb 17 12:43:37 2004
@@ -810,6 +810,7 @@
     }
 
   case CL_TmpNam:
+#if 0
     {
       char *name;
       unsigned int tnamelen, TargetID;
@@ -855,6 +856,11 @@
       Adp_ChannelWrite(CI_CLIB, packet);/* Send message. */
       return 0;
     }
+#else
+    DebugPrintF(("CL_TmpNam declared dangerous and unsupported!!\n"));
+    return 0;
+
+#endif
 
   case CL_Unrecognised:
     DebugPrintF(("CL_Unrecognised!!\n"));
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/configure.in gdb-6.0/sim/configure.in
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/configure.in	Sun Apr 13 11:44:57 2003
+++ gdb-6.0/sim/configure.in	Tue Feb 17 12:43:37 2004
@@ -91,7 +91,8 @@
 	;;
   sh*-*-*)		sim_target=sh ;;
   powerpc*-*-eabi* | powerpc*-*-solaris* | powerpc*-*-sysv4* | \
-  powerpc*-*-elf* | powerpc*-*-linux* | powerpc*-*-netbsd* )
+  powerpc*-*-elf* | powerpc*-*-linux* | powerpc*-*-netbsd* | \
+  powerpc*-*-rtems*)
 	# The PowerPC simulator uses the GCC extension long long as well as
 	# ANSI prototypes, so don't enable it for random host compilers
 	# unless asked to.
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/erc32/configure.in gdb-6.0/sim/erc32/configure.in
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/erc32/configure.in	Mon Apr 26 13:31:58 1999
+++ gdb-6.0/sim/erc32/configure.in	Tue Feb 17 12:43:37 2004
@@ -21,4 +21,7 @@
 fi
 AC_SUBST(TERMCAP)
 
+dnl Check for exe extension
+AC_EXEEXT
+
 SIM_AC_OUTPUT
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/ChangeLog gdb-6.0/sim/ppc/ChangeLog
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/ChangeLog	Sun Jun 22 11:48:09 2003
+++ gdb-6.0/sim/ppc/ChangeLog	Tue Feb 17 12:44:28 2004
@@ -1,3 +1,11 @@
+Wed Apr 29 13:54:04 CDT 1998  Joel Sherrill <joel@OARcorp.com>
+
+	* hw_sem.c: New file. Interfaces to UNIX shared memory.
+	* hw_shm.c: New file. Interfaces to UNIX semaphores.
+	* debug.c (trace_description): Added sem and shm entries.
+	* debug.h (trace_options): Added sem and shm entries.
+	* configure.in, configure (sim-hardware): Added sem and shm entries.
+
 2003-06-22  Andrew Cagney  <cagney@redhat.com>
 
 	Written by matthew green <mrg@redhat.com>, with fixes from Aldy
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/configure.in gdb-6.0/sim/ppc/configure.in
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/configure.in	Sun Jun 22 11:48:12 2003
+++ gdb-6.0/sim/ppc/configure.in	Tue Feb 17 12:43:37 2004
@@ -208,10 +208,105 @@
 esac
 ])dnl
 
+AC_CACHE_CHECK([if union semun defined],
+  ac_cv_HAS_UNION_SEMUN,
+  [AC_TRY_COMPILE([
+#include <sys/types.h>
+#include <sys/ipc.h>
+#include <sys/sem.h>],
+[union semun arg ;],
+[ac_cv_has_union_semun="yes"],
+[ac_cv_has_union_semun="no"])
+AC_MSG_RESULT($ac_cv_has_union_semun)
+])
+
+
+if test "$ac_cv_has_union_semun" = "yes"; then
+  AC_CACHE_CHECK(whether System V semaphores are supported,
+  ac_cv_sysv_sem,
+  [
+  AC_TRY_RUN(
+  [
+  #include <sys/types.h>
+  #include <sys/ipc.h>
+  #include <sys/sem.h>
+  int main () {
+    union semun arg ;
+
+    int id=semget(IPC_PRIVATE,1,IPC_CREAT|0400);
+    if (id == -1)
+      exit(1);
+    arg.val = 0; /* avoid implicit type cast to union */
+    if (semctl(id, 0, IPC_RMID, arg) == -1)
+      exit(1);
+    exit(0);
+  }
+  ],
+  ac_cv_sysv_sem="yes", ac_cv_sysv_sem="no", :)
+  ])
+else  # semun is not defined
+  AC_CACHE_CHECK(whether System V semaphores are supported,
+  ac_cv_sysv_sem,
+  [
+  AC_TRY_RUN(
+  [
+  #include <sys/types.h>
+  #include <sys/ipc.h>
+  #include <sys/sem.h>
+  union semun {
+    int val;
+    struct semid_ds *buf;
+    ushort *array;
+  };
+  int main () {
+    union semun arg ;
+
+    int id=semget(IPC_PRIVATE,1,IPC_CREAT|0400);
+    if (id == -1)
+      exit(1);
+    arg.val = 0; /* avoid implicit type cast to union */
+    if (semctl(id, 0, IPC_RMID, arg) == -1)
+      exit(1);
+    exit(0);
+  }
+  ],
+  ac_cv_sysv_sem="yes", ac_cv_sysv_sem="no", :)
+  ])
+fi
+
+AC_CACHE_CHECK(whether System V shared memory is supported,
+ac_cv_sysv_shm,
+[
+AC_TRY_RUN([
+#include <sys/types.h>
+#include <sys/ipc.h>
+#include <sys/shm.h>
+int main () {
+  int id=shmget(IPC_PRIVATE,1,IPC_CREAT|0400);
+  if (id == -1)
+    exit(1);
+  if (shmctl(id, IPC_RMID, 0) == -1)
+    exit(1);
+  exit(0);
+}
+],
+ac_cv_sysv_shm="yes", ac_cv_sysv_shm="no", :)
+])
+
+if test x"$ac_cv_sysv_shm" = x"yes" -a x"$ac_cv_sysv_sem" = x"yes" ; then
+  sim_sysv_ipc_hw=",sem,shm";
+else
+  sim_sysv_ipc_hw="";
+fi
+
+if test x"$ac_cv_has_union_semun" = x"yes" -a x"$ac_cv_sysv_sem" = x"yes" ; then
+  sim_hwflags="-DHAS_UNION_SEMUN";
+fi
+
 
 AC_ARG_ENABLE(sim-hardware,
 [  --enable-sim-hardware=list		Specify the hardware to be included in the build.],
-[hardware="cpu,memory,nvram,iobus,htab,disk,trace,register,vm,init,core,pal,com,eeprom,opic,glue,phb,ide"
+[hardware="cpu,memory,nvram,iobus,htab,disk,trace,register,vm,init,core,pal,com,eeprom,opic,glue,phb,ide${sim_sysv_ipc_hw}"
 case "${enableval}" in
   yes)	;;
   no)	AC_MSG_ERROR("List of hardware must be specified for --enable-sim-hardware"); hardware="";;
@@ -223,14 +318,13 @@
 sim_hw_obj=`echo $sim_hw_src | sed -e 's/\.c/.o/g'`
 if test x"$silent" != x"yes" && test x"$hardware" != x""; then
   echo "Setting hardware to $sim_hw_src, $sim_hw_obj"
-fi],[hardware="cpu,memory,nvram,iobus,htab,disk,trace,register,vm,init,core,pal,com,eeprom,opic,glue,phb,ide"
+fi],[hardware="cpu,memory,nvram,iobus,htab,disk,trace,register,vm,init,core,pal,com,eeprom,opic,glue,phb,ide${sim_sysv_ipc_hw}"
 sim_hw_src=`echo $hardware | sed -e 's/,/.c hw_/g' -e 's/^/hw_/' -e s'/$/.c/'`
 sim_hw_obj=`echo $sim_hw_src | sed -e 's/\.c/.o/g'`
 if test x"$silent" != x"yes"; then
   echo "Setting hardware to $sim_hw_src, $sim_hw_obj"
 fi])dnl
 
-
 AC_ARG_ENABLE(sim-hostbitsize,
 [  --enable-sim-hostbitsize=32|64	Specify host bitsize (32 or 64).],
 [case "${enableval}" in
@@ -712,6 +806,7 @@
 AC_EXEEXT
 
 AC_SUBST(CC_FOR_BUILD)
+AC_SUBST(sim_hwflags)
 AC_SUBST(CFLAGS)
 AC_SUBST(HDEFINES)
 AR=${AR-ar}
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/debug.c gdb-6.0/sim/ppc/debug.c
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/debug.c	Thu Apr 15 20:35:08 1999
+++ gdb-6.0/sim/ppc/debug.c	Tue Feb 17 12:43:37 2004
@@ -70,6 +70,8 @@
   { trace_pass_device, "pass-device" },
   { trace_phb_device, "phb-device" },
   { trace_register_device, "register-device", "Device initializing registers" },
+  { trace_sem_device, "sem-device" },
+  { trace_shm_device, "shm-device" },
   { trace_stack_device, "stack-device" },
   { trace_vm_device, "vm-device" },
   /* packages */
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/debug.h gdb-6.0/sim/ppc/debug.h
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/debug.h	Thu Apr 15 20:35:08 1999
+++ gdb-6.0/sim/ppc/debug.h	Tue Feb 17 12:43:37 2004
@@ -51,6 +51,8 @@
   trace_pal_device,
   trace_pass_device,
   trace_phb_device,
+  trace_sem_device,
+  trace_shm_device,
   trace_stack_device,
   trace_register_device,
   trace_vm_device,
diff -uNr /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/hw_sem.c gdb-6.0/sim/ppc/hw_sem.c
--- /usr1/rtems/work-tools/original/gdb-6.0/sim/ppc/hw_sem.c	Wed Dec 31 18:00:00 1969
+++ gdb-6.0/sim/ppc/hw_sem.c	Tue Feb 17 12:43:37 2004
@@ -0,0 +1,320 @@
+/*  This file is part of the program psim.
+
+    Copyright (C) 1997, Joel Sherrill <joel@OARcorp.com>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+ 
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
+ 
+    */
+
+
+#ifndef _HW_SEM_C_
+#define _HW_SEM_C_
+
+#include "device_table.h"
+
+#ifdef HAVE_STRING_H
+#include <string.h>
+#else
+#ifdef HAVE_STRINGS_H
+#include <strings.h>
+#endif
+#endif
+
+#include <sys/ipc.h>
+#include <sys/sem.h>
+
+#include <errno.h> /* XXX temporary */
+
+/* DEVICE
+
+
+   sem - provide access to a unix semaphore
+
+
+   DESCRIPTION
+
+
+   This device implements an interface to a unix semaphore.
+
+
+   PROPERTIES
+
+
+   reg = <address> <size> (required)
+
+   Determine where the memory lives in the parents address space.
+
+   key = <integer> (required)
+
+   This is the key of the unix semaphore.
+
+   EXAMPLES
+
+
+   Enable tracing of the sem:
+
+   |  bash$ psim -t sem \
+
+
+   Configure a UNIX semaphore using key 0x12345678 mapped into psim
+   address space at 0xfff00000:
+
+   |  -o '/sem@0xfff00000/reg 0xfff00000 0x80000' \
+   |  -o '/sem@0xfff00000/key 0x12345678' \
+
+   sim/ppc/run -o '/#address-cells 1' \
+         -o '/sem@0xc0000000/reg 0xc0000000 0x80000' \
+         -o '/sem@0xc0000000/key 0x12345678' ../psim-hello/hello
+
+   REGISTERS
+
+   offset 0 - lock count
+   offset 4 - lock operation   (reads count)
+   offset 8 - unlock operation (reads count)
+
+   BUGS
+
+   Only one of these can exist in a system.  I do not know how to map a
+   unique set of properties to each instance.
+
+   */
+
+typedef struct _hw_sem_device {
+  unsigned_word  physical_address;
+  key_t          key;
+  int            id;
+  int            count;
+} hw_sem_device;
+
+static void
+hw_sem_init_data(device *me)
+{
+  hw_sem_device *sem = (hw_sem_device*)device_data(me);
+  int value;
+  int status;
+#if !HAS_UNION_SEMUN
+        union semun {
+          int val;
+          struct semid_ds *buf;
+          unsigned short int *array;
+#if defined(__linux__)
+          struct seminfo *__buf;
+#endif
+        } ;
+#endif
+  union semun help;
+
+  /* initialize the properties of the sem */
+
+  if (device_find_property(me, "key") == NULL)
+    error("sem_init_data() required key property is missing\n");
+
+  if (device_find_property(me, "value") == NULL)
+    error("sem_init_data() required value property is missing\n");
+
+  sem->key = (key_t) device_find_integer_property(me, "key");
+  DTRACE(sem, ("semaphore key (%d)\n", sem->key) );
+
+  value = (int) device_find_integer_property(me, "value");
+  DTRACE(sem, ("semaphore value (%d)\n", value) );
+
+  /* Now to initialize the shared memory area */
+
+  if ( value != -1 ) {
+
+    sem->id = semget(sem->key, 1, IPC_CREAT | 0660);
+    if (sem->id == -1)
+      error("hw_sem_init_data() semget failed\n");
+
+    help.val = value;
+    status = semctl( sem->id, 0, SETVAL, help );
+    if (status == -1)
+      error("hw_sem_init_data() semctl -- set value failed\n");
+
+  } else {
+    sem->id = semget(sem->key, 1, 0660);
+    if (sem->id == -1)
+      error("hw_sem_init_data() semget failed\n");
+  }
+
+  sem->physical_address = 0xc0010000;  /* XXX hack */
+
+  sem->count = semctl( sem->id, 0, GETVAL, help );
+  if (sem->count == -1)
+    error("hw_sem_init_data() semctl -- get value failed\n");
+  DTRACE(sem, ("semaphore OS value (%d)\n", sem->count) );
+
+  if (sizeof(int) != 4)
+    error("hw_sem_init_data() typing problem\n");
+
+  /* we assume that the feedback process initializes the semaphore */
+}
+
+static void
+hw_sem_attach_address_callback(device *me,
+				attach_type attach,
+				int space,
+				unsigned_word addr,
+				unsigned nr_bytes,
+				access_type access,
+				device *client) /*callback/default*/
+{
+  hw_sem_device *sem = (hw_sem_device*)device_data(me);
+
+  if (space != 0)
+    error("sem_attach_address_callback() invalid address space\n");
+
+  if (nr_bytes == 12)
+    error("sem_attach_address_callback() invalid size\n");
+
+  sem->physical_address = addr;
+  DTRACE(sem, ("semaphore physical_address=0x%x\n", addr));
+
+}
+
+static unsigned
+hw_sem_io_read_buffer(device *me,
+			 void *dest,
+			 int space,
+			 unsigned_word addr,
+			 unsigned nr_bytes,
+			 cpu *processor,
+			 unsigned_word cia)
+{
+  hw_sem_device *sem = (hw_sem_device*)device_data(me);
+  struct sembuf sb;
+  int status;
+  unsigned32 u32;
+#if !HAS_UNION_SEMUN
+        union semun {
+          int val;
+          struct semid_ds *buf;
+          unsigned short int *array;
+#if defined(__linux__)
+          struct seminfo *__buf;
+#endif
+        } ;
+#endif
+  union semun help;
+
+  /* do we need to worry about out of range addresses? */
+
+  DTRACE(sem, ("semaphore read addr=0x%x length=%d\n", addr, nr_bytes));
+
+  if (!(addr >= sem->physical_address && addr <= sem->physical_address + 11))
+    error("hw_sem_io_read_buffer() invalid address - out of range\n");
+
+  if ((addr % 4) != 0)
+    error("hw_sem_io_read_buffer() invalid address - alignment\n");
+
+  if (nr_bytes != 4)
+    error("hw_sem_io_read_buffer() invalid length\n");
+
+  switch ( (addr - sem->physical_address) / 4 ) {
+
+    case 0:
+      break; 
+
+    case 1:  /* LOCK */
+      /*
+       *  Check for this process nesting the lock
+       */
+
+      sb.sem_num = 0;
+      sb.sem_op  = -1;
+      sb.sem_flg = 0;
+
+      status = semop(sem->id, &sb, 1);
+      if (status == -1) {
+        perror( "hw_sem.c: lock" );
+        fprintf( stderr, "Actual error number = %d\n", errno );
+        error("hw_sem_io_read_buffer() sem lock\n");
+      }
+
+      DTRACE(sem, ("semaphore lock %d\n", sem->count));
+      break; 
+
+    case 2: /* UNLOCK */
+/*
+      u32 = semctl( sem->id, 0, GETVAL, NULL );
+      if ( u32 != 1 ) {
+         fprintf( stderr, "unlock --- count = %d\n", u32 );
+      }
+*/
+      /*
+       *  Check for this process nesting the lock
+       */
+
+      sb.sem_num = 0;
+      sb.sem_op  = 1;
+      sb.sem_flg = 0;
+
+      status = semop(sem->id, &sb, 1);
+      if (status == -1) {
+        perror( "hw_sem.c: unlock" );
+        fprintf( stderr, "Actual error number = %d\n", errno );
+        error("hw_sem_io_read_buffer() sem unlock\n");
+      }
+      DTRACE(sem, ("semaphore unlock %d\n", sem->count));
+      break; 
+
+    default:
+      error("hw_sem_io_read_buffer() invalid address - unknown error\n");
+      break; 
+  }
+
+  /* XXX endian assumption here -- assume target is big endian */
+  
+  u32 = H2T_4(semctl( sem->id, 0, GETVAL, help ));
+
+  DTRACE(sem, ("semaphore OS value (%d)\n", u32) );
+  if (u32 == 0xffffffff) {
+    perror( "hw_sem.c: getval" );
+    error("hw_sem_io_read_buffer() semctl -- get value failed\n");
+  }
+
+  memcpy(dest, &u32, nr_bytes);
+  return nr_bytes;
+
+}
+
+
+static device_callbacks const hw_sem_callbacks = {
+  { generic_device_init_address, hw_sem_init_data },
+  { hw_sem_attach_address_callback, }, /* address */
+  { hw_sem_io_read_buffer, NULL }, /* IO */
+  { NULL, }, /* DMA */
+  { NULL, }, /* interrupt */
+  { NULL, }, /* unit */
+  NULL,
+};
+
+static void *
+hw_sem_create(const char *name,
+		 const device_unit *unit_address,
+		 const char *args)
+{
+  hw_sem_device *sem = ZALLOC(hw_sem_device);
+  return sem;
+}
+
+
+
+const device_descriptor hw_sem_device_descriptor[] = {
+  { "sem", hw_sem_create, &hw_sem_callbacks },
+  { NULL },
+};
+
+#endif /* _HW_SEM_C_ */
